services:
    - docker:dind

stages:
    - test
    - build
    - deploy

# Run flake8 to check for code quality
# And also optionally run unit tests
tests:
    image: python:3-bullseye
    stage: test
    variables:
        DATABASE_URL: "postgresql://admin:password@db:5432/bodyhack"
        SIGNING_KEY: "3O4TYU39Q8jgr*"
    script:
        - pip install flake8
        - flake8 api
        # Run unit tests
        - cd api
        - pip install -r requirements.txt
        - python -m pytest

# # Build API Image:
# # This job builds the API docker image and pushes it to the GitLab docker registry
# # When this job finishes you will need to use the glv-cloud-cli reset command
# # To deploy the new image
build-api-image:
    stage: build
    image: docker:git
    needs:
        - tests
    variables:
        GITLAB_IMAGE: ${CI_REGISTRY_IMAGE}/api
    before_script:
        # $CI_JOB_TOKEN is variable automatically added by Gitlab: see https://docs.gitlab.com/ee/ci/variables/predefined_variables.html#variables-reference
        - echo $CI_JOB_TOKEN | docker login -u gitlab-ci-token registry.gitlab.com --password-stdin
    script:
        - docker build --tag $GITLAB_IMAGE:latest ./api
        - docker push $GITLAB_IMAGE:latest
    only:
        - main
#Build the React/JavaScript front-end
build-front-end-job:
    stage: build
    image: node:lts-bullseye
    needs:
        - tests
    variables:
        # If either of these variables is defined in the GitLab
        # CI/CD variables, that value will override the value here.
        # You need to substitute in your real values for
        # GROUP_NAME, PROJECT_NAME, & WEBSERVICE_NAME below.
        # Don't forget to also replace PROJECT NAME in the npm run build line as well
        VITE_API_HOST: https://oct-2023-9-et-api.mod3projects.com
        VITE_PUBLIC_URL: https://anonymous-chameleon.gitlab.io/module3-project-gamma
    script:
        - cd ghi
        - npm install
        # npm run lint
        - npm run build
        # cp build/index.html build/404.html
        #     The following line creates a _redirects file to redirect all URLs to index.html
        #Documentation:
        #    https://docs.gitlab.com/ee/user/project/pages/redirects.html#rewrite-all-requests-to-a-root-indexhtml
        - echo "/* /index.html 200" > dist/_redirects

    artifacts:
        paths:
            - ghi/dist/

# # Deploy the React/JavaScript front-end to GitLab pages
# The Docker image that will be used to build your app
# Functions that should be executed before the build script is run

pages:
    stage: deploy
    rules:
        - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    dependencies:
        - build-front-end-job
    needs:
        - build-front-end-job
    script:
        - mv ghi/dist/ public
    artifacts:
        paths:
            - public
